# purefa_offload – Create, modify and delete NFS or S3 offload targets

New in version 2.8.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Status

## Synopsis

- Create, modify and delete NFS or S3 offload targets.

- Only supported on Purity v5.2.0 or higher.

- You must have a correctly configured offload network for offload to work.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.7

- purestorage

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
access_key string |  | Access Key ID of the S3 target
address string |  | The IP or FQDN address of the NFS server
api_token string / required |  | FlashArray API token for admin privileged user.
bucket string |  | Name of the bucket for the S3 target
fa_url string / required |  | FlashArray management IPv4 address or Hostname.

initialize
boolean

Choices:
- no
- yes ←

Define whether to initialize the S3 bucket

name string / required |  | The name of the offload target
options string | Default: "" | Additional mount options for the NFS share Supported mount options include port, rsize, wsize, nfsvers, and tcp or udp

protocol
string

Choices:
- nfs ←
- s3

Define which protocol the offload engine uses

secret string |  | Secret Access Key for the S3 target
share string |  | NFS export on the NFS server

state
string

Choices:
- absent
- present ←

Define state of offload

## Notes

Note

- This module requires the `purestorage` Python library

- You must set `PUREFA_URL` and `PUREFA_API` environment variables if fa_url and api_token arguments are not passed to the module directly

## Examples

    - name: Create NFS offload target
      purefa_offload:
        name: nfs-offload
        protocol: nfs
        address: 10.21.200.4
        share: "/offload_target"
        fa_url: 10.10.10.2
        api_token: e31060a7-21fc-e277-6240-25983c6c4592

    - name: Create S3 offload target
      purefa_offload:
        name: s3-offload
        protocol: s3
        access_key: "3794fb12c6204e19195f"
        bucket: offload-bucket
        secret: "wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY"
        fa_url: 10.10.10.2
        api_token: e31060a7-21fc-e277-6240-25983c6c4592

    - name: Delete offload target
      purefa_offload:
        name: nfs-offload
        protocol: nfs
        state: absent
        fa_url: 10.10.10.2
        api_token: e31060a7-21fc-e277-6240-25983c6c4592

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Pure Storage Ansible Team (@sdodsley) <pure-ansible-team@purestorage.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.